
// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyfalkon_python.h"

// main header
#include "abstractbuttoninterface_clickcontroller_wrapper.h"

// Argument includes
#include <qpoint.h>
#include <qsize.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_AbstractButtonInterface_ClickController_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(args)
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::AbstractButtonInterface::ClickController >()))
        return -1;

    ::AbstractButtonInterface::ClickController *cptr{};
    static const char fullName[] = "PyFalkon.AbstractButtonInterface.ClickController.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // ClickController()
            cptr = new ::AbstractButtonInterface::ClickController();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::AbstractButtonInterface::ClickController >(), cptr)) {
        delete cptr;
        return -1;
    }
    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_AbstractButtonInterface_ClickControllerFunc_callPopupClosed(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::AbstractButtonInterface::ClickController *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_ABSTRACTBUTTONINTERFACE_CLICKCONTROLLER_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PyFalkon.AbstractButtonInterface.ClickController.callPopupClosed";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // callPopupClosed()const
            const_cast<const ::AbstractButtonInterface::ClickController *>(cppSelf)->callPopupClosed();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_AbstractButtonInterface_ClickControllerFunc_callPopupPosition(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::AbstractButtonInterface::ClickController *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_ABSTRACTBUTTONINTERFACE_CLICKCONTROLLER_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.AbstractButtonInterface.ClickController.callPopupPosition";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: ClickController::callPopupPosition(QSize)const->QPoint
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QSIZE_IDX], (pyArg)))) {
        overloadId = 0; // callPopupPosition(QSize)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QSize cppArg0_local;
        ::QSize *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // callPopupPosition(QSize)const
            QPoint cppResult = const_cast<const ::AbstractButtonInterface::ClickController *>(cppSelf)->callPopupPosition(*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QPOINT_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_AbstractButtonInterface_ClickController_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_AbstractButtonInterface_ClickController_methods[] = {
    {"callPopupClosed", reinterpret_cast<PyCFunction>(Sbk_AbstractButtonInterface_ClickControllerFunc_callPopupClosed), METH_NOARGS, nullptr},
    {"callPopupPosition", reinterpret_cast<PyCFunction>(Sbk_AbstractButtonInterface_ClickControllerFunc_callPopupPosition), METH_O, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_AbstractButtonInterface_ClickController_get_visualParent(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::AbstractButtonInterface::ClickController *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_ABSTRACTBUTTONINTERFACE_CLICKCONTROLLER_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::pointerToPython(SbkPySide6_QtWidgetsTypes[SBK_QWIDGET_IDX], cppSelf->visualParent);
    return pyOut;
}
static int Sbk_AbstractButtonInterface_ClickController_set_visualParent(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::AbstractButtonInterface::ClickController *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_ABSTRACTBUTTONINTERFACE_CLICKCONTROLLER_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("visualParent");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(SbkPySide6_QtWidgetsTypes[SBK_QWIDGET_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("visualParent", "QWidget");
        return -1;
    }

    auto *&cppOut_ptr = cppSelf->visualParent;
    pythonToCpp(pyIn, &cppOut_ptr);

    Shiboken::Object::keepReference(reinterpret_cast<SbkObject *>(self), "visualParent", pyIn);
    return 0;
}

static PyObject *Sbk_AbstractButtonInterface_ClickController_get_popupOpened(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::AbstractButtonInterface::ClickController *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_ABSTRACTBUTTONINTERFACE_CLICKCONTROLLER_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->popupOpened;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_AbstractButtonInterface_ClickController_set_popupOpened(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::AbstractButtonInterface::ClickController *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_ABSTRACTBUTTONINTERFACE_CLICKCONTROLLER_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("popupOpened");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("popupOpened", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->popupOpened;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->popupOpened = cppOut_local;

    return 0;
}

// Getters and Setters for ClickController
static PyGetSetDef Sbk_AbstractButtonInterface_ClickController_getsetlist[] = {
    {const_cast<char *>("visualParent"), Sbk_AbstractButtonInterface_ClickController_get_visualParent, Sbk_AbstractButtonInterface_ClickController_set_visualParent, nullptr, nullptr},
    {const_cast<char *>("popupOpened"), Sbk_AbstractButtonInterface_ClickController_get_popupOpened, Sbk_AbstractButtonInterface_ClickController_set_popupOpened, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_AbstractButtonInterface_ClickController_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_AbstractButtonInterface_ClickController_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_AbstractButtonInterface_ClickController_Type = nullptr;
static PyTypeObject *Sbk_AbstractButtonInterface_ClickController_TypeF(void)
{
    return _Sbk_AbstractButtonInterface_ClickController_Type;
}

static PyType_Slot Sbk_AbstractButtonInterface_ClickController_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_AbstractButtonInterface_ClickController_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_AbstractButtonInterface_ClickController_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_AbstractButtonInterface_ClickController_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_AbstractButtonInterface_ClickController_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_AbstractButtonInterface_ClickController_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_AbstractButtonInterface_ClickController_spec = {
    "1:PyFalkon.AbstractButtonInterface.ClickController",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_AbstractButtonInterface_ClickController_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void ClickController_PythonToCpp_ClickController_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_AbstractButtonInterface_ClickController_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_ClickController_PythonToCpp_ClickController_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_AbstractButtonInterface_ClickController_TypeF()))
        return ClickController_PythonToCpp_ClickController_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *ClickController_PTR_CppToPython_ClickController(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::AbstractButtonInterface::ClickController *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_AbstractButtonInterface_ClickController_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *AbstractButtonInterface_ClickController_SignatureStrings[] = {
    "PyFalkon.AbstractButtonInterface.ClickController(self)",
    "PyFalkon.AbstractButtonInterface.ClickController.callPopupClosed(self)",
    "PyFalkon.AbstractButtonInterface.ClickController.callPopupPosition(self,size:PySide6.QtCore.QSize)->PySide6.QtCore.QPoint",
    nullptr}; // Sentinel

void init_AbstractButtonInterface_ClickController(PyObject *enclosingClass)
{
    _Sbk_AbstractButtonInterface_ClickController_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "ClickController",
        "AbstractButtonInterface::ClickController*",
        &Sbk_AbstractButtonInterface_ClickController_spec,
        &Shiboken::callCppDestructor< ::AbstractButtonInterface::ClickController >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::InnerClass);
    auto *pyType = Sbk_AbstractButtonInterface_ClickController_TypeF(); // references _Sbk_AbstractButtonInterface_ClickController_Type
    InitSignatureStrings(pyType, AbstractButtonInterface_ClickController_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_AbstractButtonInterface_ClickController_PropertyStrings);
    SbkPyFalkonTypes[SBK_ABSTRACTBUTTONINTERFACE_CLICKCONTROLLER_IDX] = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        ClickController_PythonToCpp_ClickController_PTR,
        is_ClickController_PythonToCpp_ClickController_PTR_Convertible,
        ClickController_PTR_CppToPython_ClickController);

    Shiboken::Conversions::registerConverterName(converter, "AbstractButtonInterface::ClickController");
    Shiboken::Conversions::registerConverterName(converter, "AbstractButtonInterface::ClickController*");
    Shiboken::Conversions::registerConverterName(converter, "AbstractButtonInterface::ClickController&");
    Shiboken::Conversions::registerConverterName(converter, "ClickController");
    Shiboken::Conversions::registerConverterName(converter, "ClickController*");
    Shiboken::Conversions::registerConverterName(converter, "ClickController&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::AbstractButtonInterface::ClickController).name());

    qRegisterMetaType< ::AbstractButtonInterface::ClickController *>();
}
